# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# Provides/Requires filtering is different from rpm 4.9 onwards
%global rpm49 %(rpm --version | perl -p -e 's/^.* (\\d+)\\.(\\d+).*/sprintf("%d.%03d",$1,$2) ge 4.009 ? 1 : 0/e' 2>/dev/null || echo 0)

Summary:	GNU Readline XS library wrapper
Name:		perl-Term-ReadLine-Gnu
Version:	1.35
Release:	2.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Term-ReadLine-Gnu/
Source0:	http://search.cpan.org/CPAN/authors/id/H/HA/HAYASHI/Term-ReadLine-Gnu-%{version}.tar.gz
Patch0:		Term-ReadLine-Gnu-1.35-malloc.patch
Patch2:		Term-ReadLine-Gnu-1.25-local.patch
Patch3:		Term-ReadLine-Gnu-1.34-perl588.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
# Module Build (perl-devel split from main perl package at F-7)
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	ncurses-devel
BuildRequires:	perl
%if 0%{?fedora} > 6 || 0%{?rhel} > 5
BuildRequires:	perl-devel
%endif
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
BuildRequires:	perl(Config)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(Getopt::Long)
BuildRequires:	readline-devel
# Module Runtime
BuildRequires:	perl(AutoLoader)
BuildRequires:	perl(Carp)
BuildRequires:	perl(DynaLoader)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	expect
BuildRequires:	perl(constant)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(ExtUtils::testlib)
BuildRequires:	perl(open)
BuildRequires:	perl(Term::ReadLine)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(utf8)
BuildRequires:	perl(vars)
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

# Note that optional Tk test requires a display, so isn't worth bothering with

# Don't "provide" private Perl libs, and filter out docfile dependencies (rpm 4.9 onwards)
%global __provides_exclude ^Gnu\\.so
%global __requires_exclude_from %{_docdir}/%{name}-%{version}/eg|%{_docdir}/%{name}/eg

%description
Term::ReadLine::Gnu (TRG) is an implementation of the interface to the GNU
Readline Library. This module gives you input line editing facility, input
history management facility, word completion facility, etc. It uses the real
GNU Readline Library and has the interface with the almost all variables and
functions that are documented in the GNU Readline/History Library. So you can
program your custom editing function, your custom completion function, and so
on with Perl. TRG may be useful for a C programmer to prototype a program that
uses the GNU Readline Library.

%prep
%setup -q -n Term-ReadLine-Gnu-%{version}

# Fix for CPAN RT#37194 (CPAN RT#56500) in 1.20 breaks F-9's 5.10.0 perl,
# so revert the fix there
%if "%{?fedora}" == "9"
%patch0
%endif

# We don't have perl in /usr/local/bin
%patch2

# Tweak some tests for Perl 5.8.8 support
%patch3

# Fix bogus permissions
chmod -c -x README

# Filter docfile dependencies (prior to rpm 4.9)
%if ! %{rpm49}
%global docmodules (Cwd|File::Listing|Getopt::Std|integer|Net::Domain|Net::FTP|POSIX|Term::ReadLine|Tk)
%global reqfilt /bin/sh -c "%{__perl_requires} | grep -Ev '^perl\\(%{docmodules}\\)'"
%global __perl_requires %{reqfilt}
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
find %{buildroot} -type f -name '*.bs' -empty -delete
%{_fixperms} %{buildroot}

%check
# Expect is used so that we get a PTY, as if we were
# in a real terminal, where readline works
LANG=C expect -c '
	spawn make test TEST_VERBOSE=1
	expect eof
	exit [lindex [wait] 3]
'

%clean
rm -rf %{buildroot}

%files
%doc Changes eg/ README
%{_bindir}/perlsh
%{perl_vendorarch}/Term/
%{perl_vendorarch}/auto/Term/
%{_mandir}/man1/perlsh.1*
%{_mandir}/man3/Term::ReadLine::Gnu.3*

%changelog
* Mon Jan 16 2017 Paul Howarth <paul@city-fan.org> - 1.35-2
- Rebuild for readline 7 in Rawhide

* Fri Nov  4 2016 Paul Howarth <paul@city-fan.org> - 1.35-1
- Update to 1.35
  - readline-7.0 support:
    - New functions: rl_clear_visible_line, rl_tty_set_echoing,
      rl_pending_signal
    - New variable: rl_persistent_signal_handlers
  - Gnu.xs: Fix a bug of rl_readline_state variable manifesting on a
    big-endian, sizeof(int)==4, and sizeof(long)==8 platform with the GNU
    Readline Library 7.0 (CPAN RT#118371)
- Re-diff patch for F-9 perl 5.10.0

* Tue Jul 26 2016 Paul Howarth <paul@city-fan.org> - 1.34-2
- Fix FTBFS when perl is not in the minimal buildroot

* Tue Jun 14 2016 Paul Howarth <paul@city-fan.org> - 1.34-1
- Update to 1.34
  - Improve UTF-8 handling
    - UTF-8 decoding is done at the interface between Perl and XS; this makes
      it possible for UTF-8 strings to be read from the GNU Readline Library
      functions and variables
    - Add enableUTF8() method
    - UTF-8 support is enabled when STDIN is in UTF-8 by the -C command-line
      switch, or PERL_UNICODE environment variable, or IN file handle has utf8
      IO layer, or -enableUTF8 method is called
    - Pop IO layer only when stdio layer is pushed on utf8 layer to support
      Perl 5.8.x
  - rl_save_state(), rl_restore_state(), history_get_history_state() and
    history_set_history_state() are finally implemented
  - Update RL_STATE_* definitions
  - Fix rl_readline_state and history_legnth variable to be writable
  - Fix rl_completion_quote_character and rl_completion_found_quote variable to
    be read-only
  - Update POD document
  - t/*.t: Improve and use Test::More
  - t/utf8_binary.t, t/utf8_text.t:
    - Use en_US.UTF-8 instead of en_US.utf8 for locale
    - Force the GNU Readline Library 8bit
    - Add variable access test, IO layer check, verbose mode, etc.
    - Use camel characters instead of Japanese kanji characters
  - t/utf8_binary.t: Skip when PERL_UNICODE is set (CPAN RT#114185)
  - t/utf8.txt: Use camel characters instead of Japanese kanji characters
  - t/callback.t: Update comments and code clean-up
  - Use some modern Perl features (but still in 5.8 era)
    - Use file handle references
    - Define export tags
    - Comment out 'use vars' for subroutine name alias
  - Gnu.pm, t/utf8_text.t: Fix version checks for perl 5.10.0
  - t/utf8_text.t: Fix the number of skip for systems that do not support the
    en_US.UTF-8 locale
  - Gnu.pm: Delete old formatted 'use VERSION'
  - ppport.h: Update from version 1.0007 to version 3.31
  - t/utf8_text.t: Fix for the fail when PERL_UNICODE environment variable is
    set
- BR: perl-generators where available
- Update patch for F-9 perl 5.10.0
- Add patch to fix test suite for Red Hat/Fedora Perl 5.8.8

* Sun Mar  6 2016 Paul Howarth <paul@city-fan.org> - 1.31-1
- Update to 1.31
  - t/utf8_binary.t, t/utf_text.t: skip on non UTF-8 environment
  - t/readline.t: skip the cursor move test for an active CPAN tester's
    environment
- Simplify find commands using -empty and -delete

* Wed Mar  2 2016 Paul Howarth <paul@city-fan.org> - 1.30-1
- Update to 1.30
  - t/utf8_binary.t: Add a fix to handle escape sequences that rl_initialize
    may output

* Tue Mar  1 2016 Paul Howarth <paul@city-fan.org> - 1.29-1
- Update to 1.29
  - Pop the stdio PerlIO layer only when utf8 layer is included for remote
    debugging (CPAN RT#110121)
  - Call utf8::decode() for a UTF8-enabled input filehandle (CPAN RT#104239)
  - Call newTTY() any time to set filehandles
  - Make use of 'our' instead of 'use vars'
  - Add tests for UTF-8 handling
  - Pass _rl_store_iostream 'FILE *' instead of 'PerlIO *'
  - Remove T_STDIO definition from typemap
  - Requires 5.8.1

* Wed Sep 23 2015 Paul Howarth <paul@city-fan.org> - 1.28-2
- Port Propagete-PerlIO_return_value_from_STORE.patch to 1.27/8 properly
  (#1264742)

* Tue Sep 22 2015 Paul Howarth <paul@city-fan.org> - 1.28-1
- Update to 1.28
  - Makefile.PL: revert a change on 1.27 which causes fail on the rlmalloc test
    (CPAN RT#107201)
  - t/readline.t, t/history.t: use LC_ALL instead of LANG

* Thu Sep 10 2015 Paul Howarth <paul@city-fan.org> - 1.27-2
- Fix (again) regression with Debug::Client (Bug #1189459, CPAN RT#101078)

* Sun Sep  6 2015 Paul Howarth <paul@city-fan.org> - 1.27-1
- Update to 1.27
  - readline-7.0 support: new function rl_callback_sigcleanup
  - Improve POD documents
  - Gnu.xs: do not use typedefs that were obsoleted by ReadLine 6.3
  - Fix a wrong fix in 1.21 to let completion_function do case insensitive
    match (CPAN RT#72378)
  - Fix rl_display_match_list to show the first entry of the array; the bug
    caused segmentation fault with readline-7.0
  - Some improvement of Makefile.PL:
    - Add support for homebrew on Mac OS X (CPAN RT#104389)
    - Print an error string when system() fails
    - Specify 'int' on 'main()'
    - Use -O when -D_FORTIFY_SOURCE is defined
- Explicitly BR: perl-devel, needed for EXTERN.h

* Tue Jun 16 2015 Paul Howarth <paul@city-fan.org> - 1.26-3
- Perl 5.22 rebuild

* Tue Feb 17 2015 Paul Howarth <paul@city-fan.org> - 1.26-2
- Fix regression with Debug::Client (Bug #1189459, CPAN RT#101078)

* Sun Feb  1 2015 Paul Howarth <paul@city-fan.org> - 1.26-1
- Update to 1.26
  - Call ornaments() after rl_initialize() to set tty before calling
    rl_initialize() not to output some characters to STDIO (CPAN RT#96569,
    CPAN RT#101196)
  - Make handling of iostreams simple (make _rl_store_iostream() return void
    and remove _rl_fetch_iostream()) (CPAN RT#101078)
  - Fix the Prerequisites section to require Perl 5.8 (it was required since
    TRG 1.23)
  - t/callback.t: add some new Tk-tests from CPAN Testers' site
- Drop workaround for readline < 5.2, no longer needed

* Mon Dec 22 2014 Paul Howarth <paul@city-fan.org> - 1.25-1
- Update to 1.25
  - Fix to call rl_initialize() after I/O stream setting (CPAN RT#96569)
  - t/readline.t: comment-out stty-command calls
  - t/history.t, t/readline.t: print out the corresponding section names in the
    manuals of the libraries
  - eg/perlsh: use 'IO' instead of 'FILEHANDLE', which Perl 5.20 warns
    (CPAN RT#100883)
  - Fix copyright notices to use the year of first publication
- Revert fix for CPAN RT#96569 on old distributions with readline < 5.2 as it
  breaks there
- Update patches as needed
- Classify buildreqs by usage

* Sun Mar 23 2014 Paul Howarth <paul@city-fan.org> - 1.24-1
- Update to 1.24
  - Fix not to make the PerlIO layer empty for Perl 5.8.9 or before
    (CPAN RT#59832)
  - Update Pod document assuming the use of Pod::Simple::HTMLBatch
  - t/00checkver.t: not to use 'display-readline-version') and "use Test;"
  - INSTALL: add "(Install) Using Package" section
- Update patches as needed

* Wed Mar 19 2014 Paul Howarth <paul@city-fan.org> - 1.23-1
- Update to 1.23
  - Add description of the pager command bug in Perl debugger that causes
    segmentation fault (Perl RT#121456)
  - Fix not to clobber binmode layer (utf-8) on filehandles (CPAN RT#59832)
  - Support UTF-8 input as compatible with Term::ReadLine
  - Now Term::ReadLine::Gnu requires perl 5.8.0 or above
  - Define Term::ReadLine::Gnu::ornaments method (CPAN RT#93614)
  - Makefile.PL: fix the URL of the bug-tracker (CPAN RT#93680)
  - eg/perlsh: POD syntax fix (CPAN RT#93895)
  - README: add note for bug-tracker
  - INSTALL: update "1.3 Trouble Shooting"
- Update patches
- Drop %%defattr, redundant since rpm 4.4

* Thu Mar  6 2014 Paul Howarth <paul@city-fan.org> - 1.22-1
- Update to 1.22
  - Make Kwalitee-friendly:
    - Add MakeMaker options for META.yml
    - Add Changelog
    - Fix POD errors
    - Make .pm versions consistent
    - Use "use warnings"
  - Makefile.PL dies on the CPAN Test for OpenBSD temporarily (hopefully)
- Package perlsh script and its manpage
- Update patches as needed

* Sat Mar  1 2014 Paul Howarth <paul@city-fan.org> - 1.21-1
- Update to 1.21
  - Readline-6.1 support
    - New function rl_free_keymap
    - New variable rl_filename_rewrite_hook
  - Readline-6.3 support
    - New function rl_clear_history
    - New variables rl_signal_event_hook, rl_input_available_hook,
      rl_executing_key, rl_executing_keyseq, rl_key_sequence_length,
      rl_change_environment, rl_filename_stat_hook
  - Make the following variables read-only: rl_executing_macro, history_length,
    rl_readline_state, rl_explicit_arg, rl_numeric_arg, rl_editing_mode
  - Improve backward compatiblity variable and function definitions
  - Fix Term::ReadLine::Gnu::XS::_trp_completion_function not to perform a
    case-sensitive filter
  - Fix Gnu.xs:rl_initialize to be compiled with Perl 5.8.5 or before
  - Update Pod documents
  - t/readline.t, t/history.t: add variable access tests
  - t/readline.t: consider .svn directory on filename completion test and to
    set the standard tty setting before re_initialize() being called
  - eg/perlsh makes use of the deferred signal (safe signal) feature
  - Makefile.PL checks whether the xmalloc exported by readline is indeed
    called 'xmalloc' or whether it has been renamed to '_rl_malloc'
  - Makefile.PL: add -DTRL_READLINE_VERSION to show GNU Readline Library
    version in CPAN Tester Reports
  - t/00checkver.t: let messages go to stdout
  - README: add project home page URL and remove out-of-date descriptions
  - INSTALL: add a section "Install on Mac OS X"
- Update patches as needed

* Tue Jun 12 2012 Paul Howarth <paul@city-fan.org> - 1.20-5
- BR: perl(AutoLoader), perl(Carp), perl(Exporter), perl(ExtUtils::testlib),
  perl(Getopt::Long) and perl(Term::ReadLine)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Drop RPATH removal kludge
  - Don't need to define %%{perl_vendorarch}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Thu Jul  7 2011 Paul Howarth <paul@city-fan.org> - 1.20-4
- Rebuild for perl 5.14.1 in Rawhide
- Tweak provides/requires filters for rpm 4.9 compatibility
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Thu Jun 24 2010 Paul Howarth <paul@city-fan.org> - 1.20-3
- Rebuild for perl 5.12.1 in Rawhide

* Sun May 30 2010 Paul Howarth <paul@city-fan.org> - 1.20-2
- Fix dist tag for RHEL-6 Beta

* Mon May  3 2010 Paul Howarth <paul@city-fan.org> - 1.20-1
- Update to 1.20
  - Copy environment to avoid segfaults on some systems e.g. FreeBSD
  - Skip the test of rl_readline_version for GNU Readline Library 6.1
  - readline-6.1 support: (func rl_free_keymap, var rl_filename_rewrite_hook)
- Revert environment segfault fix with perl < 5.10.1 and use our patch instead

* Fri Mar  5 2010 Paul Howarth <paul@city-fan.org> - 1.19-2
- Make requires/provides filters simpler and more generic
- Kill bogus RPATHs for distros prior to FC-2
- Dist tag for Rawhide no longer needs special-casing

* Mon Mar 23 2009 Paul Howarth <paul@city-fan.org> - 1.19-1
- Update to 1.19 (ensure the outstream fd inside the readline library is in
  sync - http://bugs.debian.org/236018; various test fixes)
- Drop visible bell test patch, no longer needed

* Fri Mar  6 2009 Paul Howarth <paul@city-fan.org> - 1.18-1
- Update to 1.18
- * better error checking of Makefile.PL
- * readline-6.0 support
- Filter out unwanted provides for perl shared objects
- Change bogus dependency filtering mechanism to tie in with provides filter
- Update to SLES-compatible dist tag macros
- No longer need to fix up permissions in %%prep

* Wed Jul  2 2008 Paul Howarth <paul@city-fan.org> - 1.17a-2
- Add Lubomir Rintel's workaround from Fedora for perl 5.10.0 build issues
  (#453287, http://rt.perl.org/rt3/Ticket/Display.html?id=56500)
  Should not be needed when Bug #453646 is fixed
- Run test suite in an "expect" wrapper (add buildreq expect, can now
  include t/readline.t again) so we get a pseudo-terminal
- Add Lubomir Rintel's patch to disable visible bell test, which fails on
  perl 5.10.0
- Tweak dist tag macros to work on current Rawhide with three-part releasenum
- Don't need buildreq bc (where did that come from?)

* Fri Feb  8 2008 Paul Howarth <paul@city-fan.org> - 1.17a-1
- Update to 1.17a
- Clarify license as GPL version 1 or later, or Artistic (i.e. same as perl)
- Don't run t/readline.t test since it's interactive
- Update patch to fix references to /usr/local/bin/perl

* Wed Jun  6 2007 Paul Howarth <paul@city-fan.org> - 1.16-3
- Fix dist tag for Fedora 7 onwards
- Add buildreq perl(ExtUtils::MakeMaker)
- Fix argument order for find with -depth

* Fri Sep  1 2006 Paul Howarth <paul@city-fan.org> - 1.16-2
- Fix distribution tags for development releases
- Define %%{__id_u} in a more portable way
- Further simplify bogus dependency filter
- Don't use macros in build-time command paths, hardcode them instead
- Carry on if tests fail (can't read /dev/tty in mock on FC5 onwards)
- Add buildreq ncurses-devel

* Tue Apr  4 2006 Paul Howarth <paul@city-fan.org> - 1.16-1
- Update to 1.16
- Remove buildroot unconditionally in %%clean and %%install
- Own directories properly
- Simplify distribution-detection
- Remove %%__perl_vendorlib macro, not used
- Remove %%__perl_version macro, used only once
- Remove %%__perl_package macro, used only twice
- Use search.cpan.org URLs
- Simplify compiler optimization flag setting
- Simplify filtering of bogus dependencies

* Fri Jun 24 2005 Paul Howarth <paul@city-fan.org> - 1.15-3
- Rewrite spec file in (mainly) Fedora Extras style
- Include full URL for source
- Fix URL
- Use MODULE_COMPAT dependency style and remove explicit perl dependency
- Include README and examples

* Thu Dec  2 2004 Paul Howarth <paul@city-fan.org> - 1.15-2
- Run "make test" with LANG=C to avoid problems with readline 4.3

* Wed Oct 27 2004 Paul Howarth <paul@city-fan.org> - 1.15-1
- Update to 1.15
- Tidy up spec file

* Thu Apr 15 2004 Paul Howarth <paul@city-fan.org> - 1.14-3
- Added explicit perl dependency to ensure that an RPM built on a
  system with an updated version of perl (and hence having files
  installed in a place that a non-updated system won't find them)
  will not install on the non-updated system. In such cases, just
  rebuild from the source RPM.
- Changed distribution-identifying macros for greater portability.

* Mon Feb 16 2004 Paul Howarth <paul@city-fan.org> - 1.14-2
- Unified spec file for Red Hat and Fedora Core

* Fri Dec 12 2003 Paul Howarth <paul@city-fan.org> - 1.14-1.fc1
- More macros
- Expanded description
- Add Fedora Core version to RPM release ID

* Wed Nov 26 2003 Paul Howarth <paul@city-fan.org> - 1.14-1
- Update to 1.14
- Patch modules to remove hardcoded references to /usr/local/bin/perl

* Mon Nov 24 2003 Paul Howarth <paul@city-fan.org>
- Tweak for Fedora

* Sat Oct 26 2002 R P Herrold <herrold@owlriver.com.com>
- Fork and re-config from Chip Turner's <cturner@redhat.com> 
  .spec for perl-Date-Calc.spec
